--Thanks to Bob and Thek.
--A refactored fork of Bob's Stupid Castbars (aka BSC)
--Available fonts are ARIALN.ttf, FRIZQT__.ttf, MORPHEUS.ttf, SKURRI.ttf

DV_CAST_BARS = {
	[1] = {
		barInfo = {
			name = "CastingBarFrame",
			height = 26,
			width = 280,
			scale = "1.0",
			point = "CENTER",
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			xOffset = 0,
			yOffset = -98,
			iconsize = 16,
			font = "Fonts\\FRIZQT__.ttf",
			style = "THINOUTLINE",
			fontsize = 14, --height-2 So the text scales with the Bar height
		},
	},
	[2] = {
		barInfo = {
			name = "TargetFrameSpellBar",
			height = 16,
			width = 180,
			scale = "1.0",
			point = "CENTER",
			relativeTo = "UIParent",
			relativePoint = "CENTER",
			xOffset = 0,
			yOffset = 0,
			iconsize = 16,
			font = "Fonts\\FRIZQT__.ttf",
			style = "THINOUTLINE",
			fontsize = 14, --height-2 So the text scales with the Bar height
		},
	},
	[3] = {
		barInfo = {
			name = "FocusFrameSpellBar",
			height = 16,
			width = 120,
			scale = "1.0",
			point = "BOTTOM",
			relativeTo = "FocusFrame",
			relativePoint = "TOP",
			xOffset = 0,
			yOffset = 0,
			iconsize = 16,
			font = "Fonts\\FRIZQT__.ttf",
			style = "THINOUTLINE",
			fontsize = 14, --height-2 So the text scales with the Bar height
		},
	},
}

for barIndex = 1, #DV_CAST_BARS do
	local barInfo = DV_CAST_BARS[barIndex].barInfo;

	_G[barInfo.name]:HookScript("OnShow", function(self)
		--Castbar
		self:SetSize(barInfo.width, barInfo.height)
		self:SetScale(barInfo.scale)
		self:ClearAllPoints()
		self:SetPoint(barInfo.point, barInfo.relativeTo, barInfo.relativePoint, barInfo.xOffset, barInfo.yOffset)
		self.SetPoint = function() end
		
		--Castbar Icon
		self.Icon:SetSize(barInfo.height, barInfo.height) --Upper case I for Icon to avoid conflicts with the icon function
		self.Icon:SetScale(barInfo.scale)
		self.Icon:ClearAllPoints()
		self.Icon:SetPoint("RIGHT", self, "LEFT", -2, 0)
		self.Icon.SetPoint = function() end

		--Castbar Timer Text
		self.timer = self:CreateFontString("FontString","OVERLAY","GameTooltipText")
		self.timer:SetPoint("RIGHT", self, "RIGHT", 0, 0)
		self.timer:SetFont(barInfo.font, barInfo.fontsize, barInfo.style)
		self.update = .1
	end)

	--Castbar Timer
	_G[barInfo.name]:HookScript("OnUpdate", function(self, elapsed)
		if not self.timer then return end
		if self.update and self.update < elapsed then
			if self.casting then
				self.timer:SetText(format("%.1f", max(self.maxValue - self.value, 0)))
			elseif self.channeling then
				self.timer:SetText(format("%.1f", max(self.value, 0)))
			else
				self.timer:SetText("")
			end
			self.update = .1
		else
			self.update = self.update - elapsed
		end
	end)
end