local addonName, addonTab = ...
	addonTab.defaults.Buffs = {
		point = "TOPRIGHT", 
		relativeTo = "dvlockcheckframe", 
		relativePoint = "TOPRIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}	
	addonTab.defaults.Debuffs = {
		point = "TOPRIGHT", 
		relativeTo = "dvlockcheckframe", 
		relativePoint = "TOPRIGHT", 
		xOffset = 0, 
		yOffset = -120,
	}	

-- DV Buff Frame
	MinimapCluster:SetFrameStrata("BACKGROUND")

local dvb = CreateFrame("Frame", "DVBFrame", dvlockcheckframe)
	dvb:RegisterEvent("PLAYER_LOGIN")
	dvb:RegisterEvent("PLAYER_ENTERING_WORLD")
	dvb:RegisterEvent("ADDON_LOADED")
	-- dvb:RegisterEvent("PET_BATTLE_OVER")
	dvb:RegisterEvent("UNIT_AURA")
	dvb:RegisterEvent("ZONE_CHANGED")
	dvb:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	dvb:RegisterEvent("ZONE_CHANGED_INDOORS")
	dvb:SetFrameStrata("HIGH")
	dvb:SetClampedToScreen(true)
	dvb:SetMovable(true)
	dvb:EnableMouse(true)
	dvb:RegisterForDrag("LeftButton")
	dvb:SetWidth(200)
	dvb:SetHeight(30)
	dvb:Show()
	
	dvb:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local points = addonTab.db.Buffs
			self:ClearAllPoints()		
			self:SetPoint(
				points.point, 
				points.relativeTo, 
				points.relativePoint, 
				points.xOffset, 
				points.yOffset)
		end
	BuffFrame:ClearAllPoints()
	BuffFrame:SetPoint("TOPRIGHT", dvb, "TOPRIGHT")
	end)
	
	dvb:SetScript("OnDragStart", dvb.StartMoving) 
	
	dvb:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		addonTab.db.Buffs.point = point
		addonTab.db.Buffs.relativeTo = relativeTo
		addonTab.db.Buffs.relativePoint = relativePoint
		addonTab.db.Buffs.xOffset = xOfs
		addonTab.db.Buffs.yOffset = yOfs		
	end)
	
local dvbframeFS = dvb:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvbFS = dvb:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvbFS:SetPoint("CENTER",dvb,"CENTER",0,0)
	dvbFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvbFS:SetText("Buffs");
	dvbFS:SetTextColor(1, 1, 1);
	
local t=dvb:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvb)
	t:SetColorTexture(0, 192, 255, 0.7)
	
-- DV Debuff Frame
local dvdbframe=CreateFrame("Frame", "dvdbframe", dvlockcheckframe)
	dvdbframe:RegisterEvent("PLAYER_LOGIN")
	dvdbframe:RegisterEvent("PLAYER_ENTERING_WORLD")
	dvdbframe:RegisterEvent("ADDON_LOADED")
	dvdbframe:RegisterEvent("UNIT_AURA")
	dvdbframe:RegisterEvent("ZONE_CHANGED")
	dvdbframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	-- dvdbframe:RegisterEvent("PLAYER_TALENT_UPDATE")
	-- dvdbframe:RegisterEvent("PLAYER_PVP_TALENT_UPDATE")
	-- dvdbframe:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
	-- dvdbframe:RegisterEvent("PET_BATTLE_OVER")
	dvdbframe:SetFrameStrata("HIGH")
	dvdbframe:SetClampedToScreen(true)
	dvdbframe:SetMovable(true)
	dvdbframe:EnableMouse(true)
	dvdbframe:RegisterForDrag("LeftButton")
	dvdbframe:SetWidth(200)
	dvdbframe:SetHeight(30)
	dvdbframe:Show()

	dvdbframe:SetScript("OnDragStart", dvdbframe.StartMoving) 
	
	dvdbframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)
		
		addonTab.db.Debuffs.point = point
		addonTab.db.Debuffs.relativeTo = relativeTo
		addonTab.db.Debuffs.relativePoint = relativePoint
		addonTab.db.Debuffs.xOffset = xOfs
		addonTab.db.Debuffs.yOffset = yOfs		
	end)

local dvdbframeFS = dvdbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvdbFS = dvdbframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvdbFS:SetPoint("CENTER",dvdbframe,"CENTER",0,0)
	dvdbFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvdbFS:SetText("Debuffs");
	dvdbFS:SetTextColor(1, 1, 1);
	
local t=dvdbframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvdbframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	
--Move Debuffs
local function movedb(frame,anchorPoint,relativeTo,relativePoint,xoff,yoff)
	frame:ClearAllPoints()
	frame:SetPoint(anchorPoint,relativeTo,relativePoint,xoff,yoff)
end

local function eventHandler(self, event, ...)
	local points = addonTab.db.Debuffs
	
	self:ClearAllPoints()		
	self:SetPoint(
		points.point, 
		points.relativeTo, 
		points.relativePoint, 
		points.xOffset, 
		points.yOffset)
				
	for _,bar in pairs({"DebuffButton"}) do
		for i=2, DEBUFF_MAX_DISPLAY do
			if _G[bar..i] then
				movedb(_G[bar..i],"RIGHT",_G[bar..(i-1)],"LEFT",-2,0)
			end
		end
	end
	for i = 1, DEBUFF_MAX_DISPLAY do
		if DebuffButton1 then
			movedb(DebuffButton1,"BOTTOMRIGHT",dvdbframe,"BOTTOMRIGHT",DebuffButton1default)
		end
		if DebuffButton6 then
			movedb(DebuffButton6,"BOTTOM",DebuffButton1,"TOP",0,14)
		end
		if DebuffButton11 then
			movedb(DebuffButton11,"BOTTOM",DebuffButton6,"TOP",0,14)
		end
		if DebuffButton16 then
			movedb(DebuffButton16,"BOTTOM",DebuffButton11,"TOP",0,14)
		end
		if DebuffButton21 then
			movedb(DebuffButton21,"BOTTOM",DebuffButton16,"TOP",0,14)
		end
		if DebuffButton26 then
			movedb(DebuffButton26,"BOTTOM",DebuffButton21,"TOP",0,14)
		end
		if DebuffButton31 then
			movedb(DebuffButton31,"BOTTOM",DebuffButton26,"TOP",0,14)
		end
		if DebuffButton36 then
			movedb(DebuffButton36,"BOTTOM",DebuffButton31,"TOP",0,14)
		end
		if DebuffButton41 then
			movedb(DebuffButton41,"BOTTOM",DebuffButton36,"TOP",0,14)
		end
	end
end

dvdbframe:SetScript("OnEvent",eventHandler)