-- Deja Tooltip

local addonName, addonTab = ...
	addonTab.defaults.DejaTooltip = {
		point = "RIGHT", 
		relativeTo = "dvlockcheckframe", 
		relativePoint = "RIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}	
	
-- DVGameTooltip
local dvgttframe=CreateFrame("Frame", "dvgttframe", dvlockcheckframe)
	dvgttframe:RegisterEvent("PLAYER_LOGIN")
	dvgttframe:SetFrameStrata("HIGH")
	dvgttframe:SetClampedToScreen(true)
	dvgttframe:SetMovable(true)
	dvgttframe:EnableMouse(true)
	dvgttframe:RegisterForDrag("LeftButton")
	dvgttframe:SetWidth(160)
	dvgttframe:SetHeight(90)
	dvgttframe:Show()

	dvgttframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local point = addonTab.db.DejaTooltip
			self:ClearAllPoints()	
			self:SetPoint(
				point.point,
				point.relativeTo,
				point.relativePoint,
				point.xOffset,
				point.yOffset)
		end
	end)

	dvgttframe:SetScript("OnDragStart", dvgttframe.StartMoving) 
	
	dvgttframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

		addonTab.db.DejaTooltip.point = point
		addonTab.db.DejaTooltip.relativeTo = relativeTo
		addonTab.db.DejaTooltip.relativePoint = relativePoint
		addonTab.db.DejaTooltip.xOffset = xOfs
		addonTab.db.DejaTooltip.yOffset = yOfs			
	end)

local dvgttframeFS = dvgttframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvgttFS = dvgttframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvgttFS:SetPoint("CENTER",dvgttframe,"CENTER",0,0)
	dvgttFS:SetFont("Fonts\\FRIZQT__.TTF", 16, "THINOUTLINE")
	dvgttFS:SetText("Tooltip");
	dvgttFS:SetTextColor(1, 1, 1);
			
local t=dvgttframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvgttframe)
	t:SetColorTexture(0, 192, 255, 0.7)

	hooksecurefunc("GameTooltip_SetDefaultAnchor", function(self, parent)
		self:SetOwner(parent, "ANCHOR_NONE")
		self:ClearAllPoints()
		self:SetPoint("BOTTOMRIGHT", dvgttframe, "BOTTOMRIGHT", 0, 0)
	end)