-- Deja unit frames
local addonName, addonTab = ...

	addonTab.defaults.DejaUnitFrames = {
		SetChecked = false,
	}	
	
local function DUFShow()
	-- Hide Player Frame Icons
	local pframe = CreateFrame("Frame", "DejapFrame")
		pframe:SetFrameStrata("BACKGROUND")
		pframe:SetWidth(372)
		pframe:SetHeight(26)
		pframe:SetPoint("CENTER", UIParent, "BOTTOM", 0, 0)
		pframe:Hide()

		pframe:RegisterEvent("PLAYER_LOGIN")
		pframe:RegisterEvent("PLAYER_ENTERING_WORLD")
		pframe:RegisterEvent("ADDON_LOADED")
		pframe:RegisterEvent("PLAYER_ENTERING_WORLD")
		pframe:RegisterEvent("ZONE_CHANGED")
		pframe:RegisterEvent("ZONE_CHANGED_INDOORS")
		pframe:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		pframe:RegisterEvent("UNIT_COMBAT")
		-- pframe:RegisterEvent("PET_BATTLE_OVER")

	--Move Player/Target/Focus Icons
		PlayerLeaderIcon:SetPoint("TOPLEFT",90,-35);
		PlayerMasterIcon:SetPoint("TOPLEFT",90,-50);
		PlayerFrameGroupIndicator:SetPoint("BOTTOMLEFT", PlayerFrame, "TOPLEFT", 97, -40);
		PlayerRestIcon:ClearAllPoints()
		PlayerRestIcon:SetPoint("RIGHT", PlayerFrame, "RIGHT", 25, 0)
		PlayerPVPIcon:ClearAllPoints()
		PlayerPVPIcon:SetPoint("LEFT", PlayerFrame, "LEFT", 55, -15)

		TargetFrameTextureFramePVPIcon:ClearAllPoints()
		TargetFrameTextureFramePVPIcon:SetPoint("RIGHT", TargetFrame, "RIGHT", -35, -15)
		TargetFrameTextureFrameLeaderIcon:ClearAllPoints()
		TargetFrameTextureFrameLeaderIcon:SetPoint("RIGHT", TargetFrame, "RIGHT", -90, 7)
		TargetFrameTextureFrameLevelText:ClearAllPoints()
		TargetFrameTextureFrameLevelText:SetPoint("LEFT", TargetFrame, "LEFT", 0, 25)
		TargetFrameTextureFrameRaidTargetIcon:ClearAllPoints()
		TargetFrameTextureFrameRaidTargetIcon:SetPoint("LEFT", TargetFrame, "LEFT", -30, 30)

		TargetFrameToT:ClearAllPoints()
		TargetFrameToT:SetPoint("LEFT", TargetFrame, "LEFT", -35, -35)
		TargetFrameToT:EnableMouse(false)

		-- FocusFrameTextureFramePVPIcon:ClearAllPoints()
		-- FocusFrameTextureFramePVPIcon:SetPoint("RIGHT", FocusFrame, "RIGHT", -35, -15)
		-- FocusFrameTextureFrameLeaderIcon:ClearAllPoints()
		-- FocusFrameTextureFrameLeaderIcon:SetPoint("RIGHT", FocusFrame, "RIGHT", -90, 7)
		-- FocusFrameTextureFrameLevelText:ClearAllPoints()
		-- FocusFrameTextureFrameLevelText:SetPoint("LEFT", FocusFrame, "LEFT", 0, 25)
		-- FocusFrameTextureFrameRaidTargetIcon:ClearAllPoints()
		-- FocusFrameTextureFrameRaidTargetIcon:SetPoint("RIGHT", FocusFrame, "RIGHT", -65, 30)

	--Move Target Frame Debuffs
		hooksecurefunc("TargetFrame_UpdateBuffAnchor", function()
			if TargetFrameBuff1 then
				TargetFrameBuff1:ClearAllPoints()
				TargetFrameBuff1:SetPoint("TOP", UIParent, "CENTER", -48, -30)
			end
		end)

		hooksecurefunc("TargetFrame_UpdateDebuffAnchor", function()
			if TargetFrameDebuff1 then
				TargetFrameDebuff1:ClearAllPoints()
				TargetFrameDebuff1:SetPoint("TOP", UIParent, "CENTER", -52, -150)
			end
		end)

	local noop = function() return end

	--Hide Player Frame Art
	for _, objname in ipairs({
		"PlayerAttackBackground",
		"PlayerAttackGlow",
		"PlayerFrameBackground",
		"PlayerFrameFlash",
		"PlayerFrameTexture",
		"PlayerHitIndicator",
		"PlayerLevelText",
		"PlayerName",
		"PlayerPortrait",
		"PlayerRestGlow",
		"PlayerStatusGlow",
		"PlayerStatusTexture",

		"TargetFrameBackground",
		"TargetFrameFlash",
		"TargetFrameNameBackground",
		"TargetFramePortrait",
		"TargetFrameTextureFrameTexture",

		"FocusFrameBackground",
		"FocusFrameFlash",
		"FocusFrameNameBackground",
		"FocusFramePortrait",
		"FocusFrameTextureFrameTexture",

		"PetAttackModeTexture",
		"PetFrameFlash",
		"PetFrameTexture",
		"PetHitIndicator",
		"PetName",
		"PetPortrait",
	}) do
		local obj = _G[objname]
		if obj then
			obj:Hide()
			obj.Show = noop
		end
	end
end

local function DUFHide()
	local noop = function() return end
	--Show Player Frame Art
	for _, objname in ipairs({
		"PlayerAttackBackground",
		"PlayerAttackGlow",
		"PlayerFrameBackground",
		"PlayerFrameFlash",
		"PlayerFrameTexture",
		"PlayerHitIndicator",
		"PlayerLevelText",
		"PlayerName",
		"PlayerPortrait",
		"PlayerRestGlow",
		"PlayerStatusGlow",
		"PlayerStatusTexture",

		"TargetFrameBackground",
		"TargetFrameFlash",
		"TargetFrameNameBackground",
		"TargetFramePortrait",
		"TargetFrameTextureFrameTexture",

		"FocusFrameBackground",
		"FocusFrameFlash",
		"FocusFrameNameBackground",
		"FocusFramePortrait",
		"FocusFrameTextureFrameTexture",

		"PetAttackModeTexture",
		"PetFrameFlash",
		"PetFrameTexture",
		"PetHitIndicator",
		"PetName",
		"PetPortrait",
	}) do
		local obj = _G[objname]
		if obj then
			obj:Show()
			obj.Hide = noop
		end
	end

end

local DejaUnitFramesCheckButton = CreateFrame("CheckButton", "DejaUnitFramesCheckButton", DejaViewClassicPanel, "InterfaceOptionsCheckButtonTemplate")
	DejaUnitFramesCheckButton:RegisterEvent("PLAYER_LOGIN")
	DejaUnitFramesCheckButton:ClearAllPoints()
	DejaUnitFramesCheckButton:SetPoint("TOP", 0, -35)
	DejaUnitFramesCheckButton:SetScale(1.25)
	DejaUnitFramesCheckButton.tooltipText = "Checked removes art from the unit frames. Unchecked displays WoW's default unit frames. Unchecking RELOADS THE UI!" --Creates a tooltip on mouseover.
	_G[DejaUnitFramesCheckButton:GetName() .. "Text"]:SetText("Remove Unit Frame Art")
	
	DejaUnitFramesCheckButton:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local checked = addonTab.db.DejaUnitFrames
			self:SetChecked(checked.SetChecked)
			if self:GetChecked(true) then
				DUFShow()
				addonTab.db.DejaUnitFrames.SetChecked = true
			else
				addonTab.db.DejaUnitFrames.SetChecked = false
			end
		end
	end)

	DejaUnitFramesCheckButton:SetScript("OnClick", function(self,event,arg1) 
		if self:GetChecked(true) then
			DUFShow()
			addonTab.db.DejaUnitFrames.SetChecked = true
		else
			addonTab.db.DejaUnitFrames.SetChecked = false
			ReloadUI();
		end
	end)